<?php /* $Id: admin.frontpage.php,v 1.10 2003/10/28 23:19:47 saka_car Exp $ */
/**
* Content code
* @package MOS
* @copyright 2000-2003 Miro International Pty Ltd
* @license http://www.gnu.org/copyleft/gpl.html. GNU Public License
* @version $Revision: 1.10 $
* @author Andrew Eddie <eddieajau@users.sourceforge.net>
*/

// ensure this file is being included by a parent file
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

require_once( $mainframe->getPath( 'admin_html' ) );
require_once( $mainframe->getPath( 'class' ) );

$act = mosGetParam( $_REQUEST, 'act', null );
$task = mosGetParam( $_REQUEST, 'task', array(0) );
$cid = mosGetParam( $_POST, 'cid', array(0) );
if (!is_array( $cid )) {
	$cid = array(0);
}

switch($act) {
	case "settings":
		switch ($task) {
			case "save":
				saveSettings( $option, $act );
				break;
			default:
				viewSettings( $option, $act );
				break;
		}
		break;
	default:
		switch ($task) {
			case "publish":
				changeFrontPage( $cid, 1, $option );
				break;

			case "unpublish":
				changeFrontPage( $cid, 0, $option );
				break;

			case "archive":
				changeFrontPage( $id, $cid, -1 );
				break;

			case "remove":
				removeFrontPage( $cid, $option );
				break;

			case "orderup":
				orderFrontPage( $cid[0], -1, $option );
				break;

			case "orderdown":
				orderFrontPage( $cid[0], 1, $option );
				break;

			default:
				viewFrontPage( $option );
				break;
		}
		break;
}

/**
* Compiles a list of frontpage items
*/
function viewFrontPage( $option ) {
	global $database, $mainframe;

	$limit = $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', 10 );
	$limitstart = $mainframe->getUserStateFromRequest( "view{$option}limitstart", 'limitstart', 0 );
	$search = $mainframe->getUserStateFromRequest( "search{$option}", 'search', '' );
	$search = $database->getEscaped( trim( strtolower( $search ) ) );

	// lets check if items have come in or out of the frontpage

	// first, insert new items
	$database->setQuery( "SELECT c.id AS content_id, f.id"
		. "\nFROM #__content AS c"
		. "\nLEFT JOIN #__content_frontpage AS f ON f.content_id=c.id"
		. "\nWHERE f.id IS NULL"
	);
	$rows = $database->loadObjectList();
	$order = 9999;
	foreach ($rows as $row) {
		$database->setQuery( "INSERT INTO #__content_frontpage"
			. "\nVALUES (0,'$row->content_id','$order')"
		);
		$database->query();
		$order++;
	}

	// second, clean up old items
	$database->setQuery( "SELECT f.id"
		. "\nFROM #__content_frontpage AS f"
		. "\nLEFT JOIN #__content AS c ON f.content_id=c.id"
		. "\nWHERE c.id is null"
	);
	$rows = $database->loadObjectList();
	foreach ($rows as $row) {
		$database->setQuery( "DELETE FROM #__content_frontpage"
			. "\nWHERE id='$row->id'"
		);
		$database->query();
	}
	$database->setQuery( "SELECT f.id"
		. "\nFROM #__content_frontpage AS f"
		. "\nINNER JOIN #__content AS c ON c.id=f.content_id AND c.mask='0'"
	);
	$rows = $database->loadObjectList();
	foreach ($rows as $row) {
		$database->setQuery( "DELETE FROM #__content_frontpage"
			. "\nWHERE id='$row->id'"
		);
		$database->query();
		$order--;
	}
	if ($order == 9999) {
		$fp = new mosFrontPage( $database );
		$fp->updateOrder();
	}

	$where = array(
	"c.state >= 0",
	"c.mask='1'"
	);

	if ($search) {
		$where[] = "LOWER(c.title) LIKE '%$search%'";
	}

	// get the total number of records
	$database->setQuery( "SELECT count(*)"
		. "\nFROM #__content AS c"
		. "\nINNER JOIN #__categories AS cc ON cc.id = c.catid"
		. "\nINNER JOIN #__sections AS s ON s.id = cc.section AND s.scope='content'"
		. (count( $where ) ? "\nWHERE " . implode( ' AND ', $where ) : "")
	);
	$total = $database->loadResult();
	echo $database->getErrorMsg();

	require_once("includes/pageNavigation.php");
	$pageNav = new mosPageNav( $total, $limitstart, $limit );

	$database->setQuery( "SELECT c.*, g.name AS groupname, cc.name, u.name AS editor, f.ordering AS fpordering"
	. "\nFROM #__content AS c"
	. "\nINNER JOIN #__categories AS cc ON cc.id = c.catid"
	. "\nINNER JOIN #__sections AS s ON s.id = cc.section AND s.scope='content'"
	. "\nINNER JOIN #__content_frontpage AS f ON f.content_id = c.id"
	. "\nINNER JOIN #__groups AS g ON g.id = c.access"
	. "\nLEFT JOIN #__users AS u ON u.id = c.checked_out"
	. (count( $where ) ? "\nWHERE " . implode( ' AND ', $where ) : "")
	. "\nORDER BY f.ordering"
	. "\nLIMIT $pageNav->limitstart,$pageNav->limit"
	);

	$rows = $database->loadObjectList();
	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	HTML_content::showList( $rows, $search, $pageNav, $option );
}

/**
* Compiles information to add or edit the record
* @param database A database connector object
* @param integer The unique id of the record to edit (0 if new)
* @param integer The id of the content section
*/
function editFrontPage( $uid, $sectionid=0 ) {
	global $database, $my;
	global $mosConfig_absolute_path, $mosConfig_live_site;
}

/**
* Changes the state of one or more content pages
* @param array An array of unique category id numbers
* @param integer 0 if unpublishing, 1 if publishing
*/
function changeFrontPage( $cid=null, $state=0, $option ) {
	global $database;

	if (count( $cid ) < 1) {
		$action = $publish == 1 ? 'publish' : ($publish == -1 ? 'archive' : 'unpublish');
		echo "<script> alert('Select an item to $action'); window.history.go(-1);</script>\n";
		exit;
	}

	$cids = implode( ',', $cid );

	$database->setQuery( "UPDATE #__content SET state='$state'"
	. "\nWHERE id IN ($cids) AND (checked_out=0 OR (checked_out='$my->id'))"
	);
	if (!$database->query()) {
		echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	if (count( $cid ) == 1) {
		$row = new mosContent( $database );
		$row->checkin( $cid[0] );
	}

	mosRedirect( "index2.php?option=$option" );
}

function removeFrontPage( &$cid, $option ) {
	global $database;

	if (!is_array( $cid ) || count( $cid ) < 1) {
		echo "<script> alert('Select an item to delete'); window.history.go(-1);</script>\n";
		exit;
	}
	if (count( $cid )) {
		$cids = implode( ',', $cid );
		$database->setQuery( "DELETE FROM #__content WHERE id IN ($cids)" );
		if (!$database->query()) {
			echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}
	}

	mosRedirect( "index2.php?option=$option" );
}

/**
* Moves the order of a record
* @param integer The increment to reorder by
*/
function orderFrontPage( $uid, $inc, $option ) {
	global $database;

	$limit = mosGetParam( $_REQUEST, 'limit', 0 );
	$limitstart = mosGetParam( $_REQUEST, 'limitstart', 0 );

	$database->setQuery( "SELECT id"
		. "\nFROM #__content_frontpage"
		. "\nWHERE content_id='$uid'"
	);
	$msg='';
	if ($fid = $database->loadResult()) {
		$fp = new mosFrontPage( $database );
		$fp->load( $fid );
		$fp->move( $inc );
	} else {
		$msg = $database->getErrorMsg();
	}

	mosRedirect( "index2.php?option=$option&limit=$limit&limitstart=$limitstart&mosmsg=$msg" );
}

/**
* Displays front page settings option
*/
function viewSettings( $option, $act ) {
	global $database;

	$database->setQuery( "SELECT col_main FROM #__templates WHERE id=0" );
	$col = $database->loadResult();

	HTML_content::showSettings( $col, $option, $act );
}

/**
* Saves front page settings options
*/
function saveSettings( $option, $act ) {
	GLOBAL $database;
	$col_main = mosGetParam( $_POST, 'col_main', 1 );
	$database->setQuery( "UPDATE #__templates SET col_main=$col_main WHERE id=0" );
	if (!$database->query()) {
		echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
	}
	mosRedirect( "index2.php?mosmsg=The%20frontpage%20settings%20have%20been%20updated!" );
}
?>