<?php
// $Id: admin.users.php,v 1.7 2003/10/29 14:48:02 rcastley Exp $
/**
* Users event handler
* @package Mambo Open Source
* @Copyright (C) 2000 - 2003 Miro International Pty Ltd
* @ All rights reserved
* @ Mambo Open Source is Free Software
* @ Released under GNU/GPL License: http://www.gnu.org/copyleft/gpl.html
* @version $Revision: 1.7 $
**/

// ensure this file is being included by a parent file
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

require_once( $mainframe->getPath( 'admin_html' ) );

$task = trim( mosGetParam( $_REQUEST, 'task', null ) );
$cid = mosGetParam( $_REQUEST, 'cid', array( 0 ) );
if (!is_array( $cid )) {
	$cid = array ( 0 );
}

switch ($task) {
	case "new":
		editUser( 0, $option);
		break;

	case "edit":
		editUser( $cid[0], $option );
		break;

	case "save":
		saveUser( $option );
		break;

	case "remove":
		removeUsers( $cid, $option );
		break;

	default:
		showUsers( $option );
		break;
}

function showUsers( $option ) {
	global $database, $mainframe, $my;

	$limit = $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', 10 );
	$limitstart = $mainframe->getUserStateFromRequest( "view{$option}limitstart", 'limitstart', 0 );
	$search = $mainframe->getUserStateFromRequest( "search{$option}", 'search', '' );
	$search = $database->getEscaped( trim( strtolower( $search ) ) );

	$where = "(t.id > m.id OR a.id='$my->id')";
	if (isset($search) && $search!= "") {
		$where .= " AND username LIKE '%$search%' OR email LIKE '%$search%' OR a.name LIKE '%$search%'";
	}
	if ($my->usertype == 'administrator') {
		$where .= $where ? ' AND ' : '';
		$where .= "usertype <> 'superadministrator' AND ("
			. "\n	usertype <> 'administrator' OR ("
			. "\n		usertype = 'administrator' AND a.id = '$my->id'"
			. "\n	))";
	}

	$database->setQuery( "SELECT COUNT(*)"
		. "\nFROM #__users AS a"
		. "\nINNER JOIN mos_usertypes AS t ON t.name=a.usertype"
		. "\nINNER JOIN mos_usertypes AS m ON m.name='$my->usertype'"
		. "\nWHERE $where"
	);
	$total = $database->loadResult();
	echo $database->getErrorMsg();

	require_once("includes/pageNavigation.php");
	$pageNav = new mosPageNav( $total, $limitstart, $limit  );

	$database->setQuery( "SELECT a.*, g.name AS groupname"
		. "\nFROM #__users AS a"
		. "\nINNER JOIN #__groups AS g ON g.id = a.gid"
		. "\nINNER JOIN mos_usertypes AS t ON t.name=a.usertype"
		. "\nINNER JOIN mos_usertypes AS m ON m.name='$my->usertype'"
		. "\nWHERE $where"
		. "\nGROUP BY usertype,username"
		. "\nORDER BY usertype"
		. "\nLIMIT $pageNav->limitstart, $pageNav->limit"
	);

	$rows = $database->loadObjectList();
	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	HTML_users::showUsers( $rows, $pageNav, $search, $option );
}

function editUser( $uid='0', $option='users' ) {
	global $database, $my;

	$row = new mosUser( $database );
	// load the row from the db table
	$row->load( $uid );

	// get list of groups
	$database->setQuery( "SELECT id AS value, name AS text FROM #__groups WHERE name <> 'Public' ORDER BY id" );
	$rows = $database->loadObjectList();

	$groupslist = mosHTML::selectList( $rows, 'gid', "class=\"inputbox\" size=\"1\"",
	'value', 'text', $row->gid );

	// Get list of usertypes
	$database->setQuery( "SELECT t.name AS value, t.name AS text"
		. "\nFROM #__usertypes AS t"
		. "\nINNER JOIN mos_usertypes AS m ON m.name='$my->usertype'"
		. "\nWHERE t.id > m.id"
		. "\nORDER BY t.id"
	);
	$rows = $database->loadObjectList();
	echo $database->getErrorMsg();

	$typeslist = mosHTML::selectList( $rows, 'usertype', "class=\"inputbox\" size=\"1\"",
	'value', 'text', $row->usertype );

// make the select list for yes/no fields
	$yesno[] = mosHTML::makeOption( '0', 'No' );
	$yesno[] = mosHTML::makeOption( '1', 'Yes' );

// build the html select list
	$blocklist = mosHTML::selectList( $yesno, 'block', 'class="inputbox" size="1"',
		'value', 'text', $row->block );

// build the html select list
	$emaillist = mosHTML::selectList( $yesno, 'sendEmail', 'class="inputbox" size="1"',
		'value', 'text', $row->sendEmail );

	HTML_users::edituser( $row, $groupslist, $typeslist, $blocklist, $emaillist, $option );
}

function saveUser( $option ) {
	global $database, $my;
	global $mosConfig_live_site;

	$row = new mosUser( $database );
	if (!$row->bind( $_POST )) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}
	$isNew = !$row->id;
	$pwd = '';
	if ($isNew) {
		// new user stuff
		if ($row->password == '') {
			$pwd = mosMakePassword();
			$row->password = md5( $pwd );
		} else {
			$pwd = $row->password;
			$row->password = md5( $row->password );
		}
	} else {
		// existing user stuff
		if ($row->password == '') {
			// password set to null if empty
			$row->password = null;
		} else {
			$row->password = md5( $row->password );
		}
	}

	if (!$row->check()) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->store()) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}
	$row->checkin();
	if ($isNew) {
		$database->setQuery( "SELECT email FROM #__users WHERE id=$my->id" );
		$adminEmail = $database->loadResult();

		$subject = "New User Details";
		$message = "Hello $row->name,\r \n \r \n";
		$message .= "You have been added as a $row->usertype to $mosConfig_live_site by an Administrator.\r \n";
		$message .= "This email contains your username and password to log into the $mosConfig_live_site site:\r \n \r \n";
		$message .= "Username - $row->username\r \n";
		$message .= "Password - $pwd\r \n \r \n \r \n";
		$message .= "Please do not respond to this message as it is automatically generated and is for information purposes only\r \n";

		$headers = "MIME-Version: 1.0\r \n";
		$headers .= "From: $adminEmail\r \n";
		$headers .= "Reply-To: $adminEmail\r \n";
		$headers .= "X-Priority: 3\r \n";
		$headers .= "X-MSMail-Priority: Low\r \n";
		$headers .= "X-Mailer: Mambo Open Source 4.5\r \n";

		mail( $row->email, $subject, $message, $headers );
	}

	$limit = intval( mosGetParam( $_REQUEST, 'limit', 10 ) );
	$limitstart	= intval( mosGetParam( $_REQUEST, 'limitstart', 0 ) );
	mosRedirect( "index2.php?option=$option&limit=$limit&limitstart=$limitstart" );
}

function removeUsers( $cid, $option ) {
	global $database;

	if (!is_array( $cid ) || count( $cid ) < 1) {
		echo "<script> alert('Select an item to delete'); window.history.go(-1);</script>\n";
		exit;
	}
	if (count( $cid )) {
		$cids = implode( ',', $cid );
		$database->setQuery( "DELETE FROM #__users WHERE id IN ($cids)" );
		if (!$database->query()) {
			echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}
	}

	$limit = intval( mosGetParam( $_REQUEST, 'limit', 10 ) );
	$limitstart	= intval( mosGetParam( $_REQUEST, 'limitstart', 0 ) );
	mosRedirect( "index2.php?option=$option&limit=$limit&limitstart=$limitstart" );
}

function is_email($email){
	$rBool=false;

	if(preg_match("/[\w\.\-]+@\w+[\w\.\-]*?\.\w{1,4}/", $email)){
		$rBool=true;
	}
	return $rBool;
}
?>
