<?php
// $Id: index2.php,v 1.31 2003/11/09 17:26:07 rcastley Exp $
/**
* Administrator authenticated index page
* @package Mambo Open Source
* @Copyright (C) 2000 - 2003 Miro International Pty Ltd
* @ All rights reserved
* @ Mambo Open Source is Free Software
* @ Released under GNU/GPL License: http://www.gnu.org/copyleft/gpl.html
* @version $Revision: 1.31 $
**/

// aim to have code so that following line is on without errors
// and not have regglobals include
//error_reporting( E_ALL );
//$mosConfig_debug = false;

define( "_VALID_MOS", 1 );

require_once( "../globals.php" );
require_once( "../configuration.php" );
require_once( "../classes/mambo.php" );
include_once( "../language/".$mosConfig_lang.".php" );
require_once( "classes/admin.php" );
include_once( $mosConfig_absolute_path . "/includes/debug.php" );
include_once( "../editor/editor.php" );

$database = new database( $mosConfig_host, $mosConfig_user, $mosConfig_password, $mosConfig_db, $mosConfig_dbprefix );
$option = trim( strtolower( mosgetParam( $_REQUEST, 'option', '' ) ) );

// must start the session before we create the mainframe object
session_name( 'mosadmin' );
session_start();

// mainframe is an API workhorse, lots of 'core' interaction routines
$mainframe = new mosMainFrame( $database, $option, '..' );

// Support for simple debug
$mosDebug = new mosDebug( $mosConfig_debug );

// initialise some common request directives
$task = trim( mosgetParam( $_REQUEST, 'task', '' ) );
$act = trim( strtolower( mosgetParam( $_REQUEST, 'act', '' ) ) );
$section = trim( mosgetParam( $_REQUEST, 'section', '' ) );
$mosmsg = trim( strip_tags( mosgetParam( $_REQUEST, 'mosmsg', '' ) ) );
$no_html = strtolower( trim( mosGetParam( $_REQUEST, 'no_html', '' ) ) );


if ($option == 'logout') {
	require 'logout.php';
	exit();
}

// restore some session variables
$my = new mosUser( $database );
$my->id = $_SESSION['session_user_id'];
$my->username = $_SESSION['session_username'];
$my->usertype = $_SESSION['session_usertype'];

$session_id = mosGetParam( $_SESSION, 'session_id', '' );
$logintime = mosGetParam( $_SESSION, 'session_logintime', '' );

// check against db record of session
if ($session_id == md5( $my->id.$my->username.$my->usertype.$logintime )) {
	$database->setQuery( "SELECT * FROM #__session"
	. "\nWHERE session_id='$session_id'"
	. "\n	AND (usertype='administrator' OR usertype='superadministrator')"
	);
	if (!$result = $database->query()) {
		echo $database->stderr();
	}
	if ($database->getNumRows( $result ) <> 1) {
		echo "<script>document.location.href='index.php'</script>\n";
		exit();
	}
} else {
	echo "<script>document.location.href='index.php'</script>\n";
	exit();
}

// update session timestamp
$current_time = time();
$database->setQuery( "UPDATE #__session SET time='$current_time'"
. "\nWHERE session_id='$session_id'"
);
$database->query();

// timeout old sessions
$past = time()-1800;
$database->setQuery( "DELETE FROM #__session WHERE time < '$past'" );
$database->query();

// check for database backup
if (($option == "dbadmin") && ($task == "doBackup")) {
	$OutDest = mosGetParam( $_REQUEST, "OutDest", '' );
	if ($OutDest == "remote") {
		include_once ("dbadmin.php");
		exit();
	}
}

// start the html output
if ($no_html) {
	if ($path = $mainframe->getPath( "admin" )) {
		require $path;
	}
	exit;
}
// start the output buffer
if (extension_loaded('zlib')) {
        ob_start('ob_gzhandler');
} else {
        ob_start();
}

?>
<?php echo "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?".">"; ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title><?php echo $mosConfig_sitename; ?> :: Administration [Mambo Open Source]</title>
<link rel="bookmark" href="../images/favicon.ico" />
<link rel="shortcut icon" href="../images/favicon.ico" />
<link rel="stylesheet" href="css/admin.css" type="text/css" />
<link rel="stylesheet" href="../includes/js/ThemeOffice/theme.css" type="text/css" />
<script language="JavaScript" src="../includes/js/JSCookMenu.js" type="text/javascript"></script>
<script language="JavaScript" src="js/ThemeOffice/theme.js" type="text/javascript"></script>
<script language="JavaScript1.2" src="js/rollover.js" type="text/javascript"></script>
<script language="JavaScript" src="../includes/js/mambojavascript.js" type="text/javascript"></script>
<?php
initEditor();
echo _ISO; ?>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
</head>
<body onload="MM_preloadImages('images/help_f2.png','images/approve_f2.png','images/archive_f2.png','images/back_f2.png','images/cancel_f2.png','images/delete_f2.png','images/edit_f2.png','images/new_f2.png','images/preview_f2.png','images/publish_f2.png','images/save_f2.png','images/unarchive_f2.png','images/unpublish_f2.png','images/upload_f2.png')">
<?php
$mosDebug->showvar( $_REQUEST );
// pull in the menu bar
require_once( "menubar.php" );

if ($mosmsg) {
	if (!get_magic_quotes_gpc()) {
		$mosmsg = addslashes( $mosmsg );
	}
	echo "\n<script language=\"javascript\" type=\"text/javascript\">alert('$mosmsg');</script>";
}
?>
<table width="98%" border="0" align="center" cellpadding="0" cellspacing="0">
  <tr> 
    <td width="10" height="10" background="images/top_left_corner.png"></td>
    <td background="images/top_line.png"></td>
    <td width="10" height="10" background="images/top_right_corner.png"></td>
  </tr>
  <tr> 
    <td background="images/left_line.png"></td>
    <td valign="middle" align="center"> 
      <?php

// Show list of items to edit or delete or create new
if ($path = $mainframe->getPath( 'admin' )) {
	require $path;
} else {
	?>
      <img src="images/mos_logo.png" border="0" alt="MOS Logo" />&nbsp; <br /> 
      <?php
}
?>
    </td>
    <td background="images/right_line.png"></td>
  </tr>
  <tr> 
    <td width="10" height="10" background="images/bottom_left_corner.png"></td>
    <td background="images/bottom_line.png"></td>
    <td width="10" height="10" background="images/bottom_right_corner.png"></td>
  </tr>
</table>
</body>
</html>
<?php
ob_end_flush();
?>
