<?php
// $Id: index.php,v 1.20 2003/11/09 17:26:07 rcastley Exp $
/**
* Main index.php file
* @package Mambo Open Source
* @Copyright (C) 2000 - 2003 Miro International Pty Ltd
* @ All rights reserved
* @ Mambo Open Source is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version $Revision: 1.20 $
**/

// aim to have code so that following line is on without errors
// and not have regglobals include
//error_reporting( E_ALL );

define( "_VALID_MOS", 1 );

if (!file_exists( "configuration.php" )) {
	header( "Location: installation/index.php" );
	exit();
}

include_once( "globals.php" );
require_once( "configuration.php" );
require_once( "classes/mambo.php" );
require_once( "includes/sef.php" );
require_once( "includes/frontend.php" );

if ($mosConfig_offline == 1){
	include( 'offline.php' );
	exit();
}

// retrieve some expected url (or form) arguments
$option = trim( strtolower( mosgetParam( $_REQUEST, 'option' ) ) );
$Itemid = intval( mosgetParam( $_REQUEST, 'Itemid', 0 ) );
$database = new database( $mosConfig_host, $mosConfig_user, $mosConfig_password, $mosConfig_db, $mosConfig_dbprefix );

if ($option == '') {
	if ($Itemid) {
		$database->setQuery( "SELECT id, link"
			. "\nFROM #__menu"
			. "\nWHERE menutype='mainmenu' AND id='$Itemid' AND published='1'"
		);
	} else {
		$database->setQuery( "SELECT id, link"
			. "\nFROM #__menu"
			. "\nWHERE menutype='mainmenu' AND published='1'"
			. "\nORDER BY parent, ordering LIMIT 1" );
	}
	$menu = new mosMenu( $database );
	if ($database->loadObject( $menu )) {
		$Itemid = $menu->id;
	}
	$link = $menu->link;
	if (($pos = strpos( $link, '?' )) !== false) {
		$link = substr( $link, $pos+1 ). '&Itemid='.$Itemid;
	}
	parse_str( $link, $temp );
	// this is a patch, need to rework when globals are handled better
	foreach ($temp as $k=>$v) {
		$GLOBALS[$k] = $v;
		$_REQUEST[$k] = $v;
		if ($k == 'option') {
			$option = $v;
		}
	}
}
// do we have a valid Itemid yet??
if ($Itemid < 1) {
	// Nope, just use the homepage then.
	$database->setQuery( "SELECT id"
		. "\nFROM #__menu"
		. "\nWHERE menutype='mainmenu' AND published='1'"
		. "\nORDER BY parent, ordering LIMIT 1"
	);
	if (!($Itemid = $database->loadResult())) {
		echo $database->getErrorMsg();
	}
}

// patch to lessen the impact on templates
if ($option == 'search') {
	$option = 'com_search';
}

// mainframe is an API workhorse, lots of 'core' interaction routines
$mainframe = new mosMainFrame( $database, $option, '.' );

// Support for simple debug
include_once($mosConfig_absolute_path . "/includes/debug.php");
$mosDebug = new mosDebug($mosConfig_debug);

$mainframe->initSession();

if ($mosConfig_lang=='') {
	$mosConfig_lang='english';
}
include_once ('language/'.$mosConfig_lang.'.php');

if ($option == "login") {
	$mainframe->login();
	mosRedirect('index.php');
} else if ($option == "logout") {
	$mainframe->logout();
	mosRedirect( "index.php" );
}

// get the information about the current user from the sessions table
$my = $mainframe->getUser();

// detect first visit
$mainframe->detect();

$gid = intval( $my->gid );

$cur_template = $mainframe->getTemplate();
$col_main = 1;		// temp fix - this feature is currently disabled

header ("Expires: Mon, 26 Jul 1997 05:00:00 GMT");	// Date in the past
header ("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");	// always modified


if (extension_loaded('zlib')) {
	ob_start('ob_gzhandler');
} else {
	ob_start();
}
require_once( "templates/$cur_template/index.php" );
ob_end_flush();
?>
