<?php
// $Id: index2.php,v 1.21 2003/11/09 22:56:12 rcastley Exp $
/**
* Print/e-mail/RSS code
* @package Mambo Open Source
* @Copyright (C) 2000 - 2003 Miro International Pty Ltd
* @ All rights reserved
* @ Mambo Open Source is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version $Revision: 1.21 $
**/

/**
* Support file to display an operation clear of the template
*/


define( "_VALID_MOS", 1 );

include_once ("globals.php");
require_once ("configuration.php");
require_once ("classes/mambo.php");
require_once ("includes/sef.php");
require_once ("includes/frontend.php");

$database = new database( $mosConfig_host, $mosConfig_user, $mosConfig_password, $mosConfig_db, $mosConfig_dbprefix );

// mainframe is an API workhorse, lots of 'core' interaction routines
$mainframe = new mosMainFrame( $database, $option, '.' );

// Support for simple debug
if ($mosConfig_debug) {
	include_once($mosConfig_absolute_path . "/includes/debug.php");
	$mosDebug = new mosDebug($mosConfig_debug);
}

// retrieve some expected url (or form) arguments
$option = strtolower( trim( mosGetParam( $_REQUEST, 'option', $mosConfig_defaultpage ) ) );
$no_html = intval( mosGetParam( $_REQUEST, 'no_html', 0 ) );
$Itemid = strtolower( trim( mosGetParam( $_REQUEST, 'ItemId',0 ) ) );
$mainframe->initSession();

if ($mosConfig_lang=='') {
	$mosConfig_lang='english';
}
include_once ('language/'.$mosConfig_lang.'.php');

if ($mosConfig_offline == 1){
	include( 'offline.php' );
	exit();
}

if ($option == "login") {
	$mainframe->login();
	mosRedirect('index.php');
} else if ($option == "logout") {
	$mainframe->logout();
	mosRedirect( "index.php" );
}

// get the information about the current user from the sessions table
$my = $mainframe->getUser();

$mainframe->detect();

$gid = intval( $my->gid );

/*
Create a text only PDF - reference for commands available at: http://www.ros.co.nz/pdf/readme.pdf
Implemented by Phil Taylor - Images are really difficult but can be added if really needed
*/
if ($act=="pdf"){
	include('classes/class.ezpdf.php');
	global $mosConfig_offset;
	$row = new mosContent( $database );
	$row->load($id);
	//Find Author Name
	if (!$row->created_by_alias){
		$users_rows = new mosUser( $database );
		$users_rows->load($row->created_by);
	}
	// Ugly but needed to get rid of all the stuff the PDF class cant handle
	$row->introtext = str_replace('<p>', "\n\n", $row->introtext);
	$row->fulltext = str_replace('<p>', "\n\n" , $row->fulltext);
	$row->introtext = str_replace('<P>', "\n\n", $row->introtext);
	$row->fulltext = str_replace('<P>', "\n\n" , $row->fulltext);
	$row->introtext = str_replace('<li>', "   - " , $row->introtext);
	$row->fulltext = str_replace('<li>', "   - " , $row->fulltext);
	$row->introtext = str_replace('<LI>', "   - " , $row->introtext);
	$row->fulltext = str_replace('<LI>', "   - " , $row->fulltext);
	$row->introtext = strip_tags($row->introtext);
	$row->introtext = str_replace( '{mosimage}', '', $row->introtext );
	$row->introtext = str_replace( '{mospagebreak}', '', $row->introtext );
	$row->fulltext = strip_tags($row->fulltext);
	$row->fulltext = str_replace( '{mosimage}', '', $row->fulltext );
	$row->fulltext = str_replace( '{mospagebreak}', '', $row->fulltext );
	$row->fulltext = decodeHTML($row->fulltext);
	$row->introtext = decodeHTML($row->introtext);
	
	$pdf =& new Cezpdf('a4','P');  //A4 Portrait
	$pdf -> ezSetCmMargins(2,1.5,1,1);
	$pdf->selectFont('./fonts/Helvetica.afm'); //choose font
	
	$all = $pdf->openObject();
	$pdf->saveState();
	$pdf->setStrokeColor(0,0,0,1);
	$pdf->line(10,40,578,40);
	$pdf->line(10,822,578,822);
	$pdf->addText(30,34,6,$mosConfig_live_site . " - " . $mosConfig_sitename);
	$pdf->addText(250,34,6,"Powered by Mambo Open Source");
	$pdf->addText(450,34,6,"Generated: " . date("j F, Y, H:i", time()+$mosConfig_offset*60*60));
	$pdf->restoreState();
	$pdf->closeObject();
	$pdf->addObject($all,'all');
	$pdf->ezSetDy(30);
	
	$txt = $row->title;
	$pdf->ezText($txt,14);
	$txt = "(" . $row->created . ") - Written by: ";
	$txt .= $row->created_by_alias ? $row->created_by_alias : $users_rows->name . "\n";
	$txt .= "\n\n";
	$pdf->ezText($txt,8);
	//$pdf->ezImage('images/cancel.png','5','','none','left');
	$txt2 ="$row->introtext\n$row->fulltext";
	$pdf->ezText($txt2,10);
	
	$pdf->ezStream();
	
} else {
	
	$t = new mosTemplate( $database );
	$t->load( 0 );
	$cur_template = $t->cur_template;
	
	ob_start();
	// start basic HTML
if ($no_html==0){?>
<?php echo "<?xml version=\"1.0\"?>"; ?>
	 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<title><?php echo $mosConfig_sitename; ?></title>
		<link rel="stylesheet" href="templates/<?php echo $cur_template;?>/css/template_css.css" type="text/css" />
		<?php echo _ISO; ?>
	</head>
	<body>
		<?php include ("mainbody.php"); ?>
		<div align="center"><a href="#" onclick="window.close()"><?php echo _PROMPT_CLOSE; ?></a></div>
	</body>
	</html>
<?php
} else {
	include ("mainbody.php");
}
ob_end_flush();
}

function decodeHTML($string) {
	$string = strtr($string, array_flip(get_html_translation_table(HTML_ENTITIES)));
	$string = preg_replace("/&#([0-9]+);/me", "chr('\\1')", $string);
	return $string;
}
?>
